
#include <math.h>
#include <ddraw.h>

#include "../vjeffect.h"
#include "../gfxpixel.h"


//--------------------------------------------------------------------------
// NX`
//--------------------------------------------------------------------------
// NX͊{I [Copy/Mix/Modify/Generate]+[ŗL̖O] œꂵĂD
//  Copy : In x 1  , Out x 1 (Rs[)
//  Mix  : In x 2+ , Out x 1 (Qȏ̃\[XɃRs[)
//  Modify :       , Out x 1 (o͐ω)
//  Generate :     , Out x 1 (摜𐶐)

// Release() : ~CVJCopy()OQƂȂ,ɑ̂Lq (ėǂł)
// MessageProc() : VJM_??? bZ[W󂯎֐łDfBXpb`ĂD

// 
class CVJGenerateWave : public CVJEffecter
{
public:
	CVJGenerateWave();
	~CVJGenerateWave();

	void Release();
	int MessageProc(int,DWORD,DWORD);
	VJOBJINFO* GetInfo();

	int Effect(VJEFFECTINFO*);

};

//--------------------------------------------------------------------------
// VJEffecterNX`
//--------------------------------------------------------------------------
// {̂ɓnNX̏ڍׂłDK`ĂD


CVJEffecter* GetVJGenerateWave(){return new CVJGenerateWave();}

VJOBJINFO VJOBJGenerateWave=
{
	sizeof(VJOBJINFO),
	VJ_EFFECT_GENERATE,
	"GenerateWave",
	1,			//num of out channel
	0,			//num of in channel
	1+2,		//num of param
	NULL,
	&GetVJGenerateWave
};

VJOBJINFO* CVJGenerateWave::GetInfo(){return &VJOBJGenerateWave;}




//--------------------------------------------------------------------------
// GtFNg֐`
//--------------------------------------------------------------------------

struct SoundCaptureBuffer{
	DWORD size;
	SHORT data[0];
} ;

template <class VOUT>
static void EffectGenerateWave(VJEFFECTINFO *pInfo,
						   VOUT *pvo,DDSURFACEDESC *pdesko)
{
	

	VOUT *pVo=(VOUT*)pdesko->lpSurface;


	int height=pdesko->dwHeight;
	int width= pdesko->dwWidth ;
	

	int x,y;
	int u,v;
	int i;
	int r,g,b;

	int center;

	
	int pdesko_lPitch=pdesko->lPitch;

	SoundCaptureBuffer *pBuf=(SoundCaptureBuffer*)pInfo->pParam[1].data;
	if(pBuf==NULL) return;
	int brend=pInfo->pParam[1].data;

	x=width-1;
	if(x>=pBuf->size) x=pBuf->size-1;
	for(;x>=0;x--)
	{
		VOUT *p;

		y=(height/2)+(pBuf->data[x*2]>>8);
		if(y<0) y=0; else if(y>=height) y=height-1;
		p=(VOUT*) ( (BYTE*) pvo+pdesko_lPitch*y);
		p+=x;
		p->SetRGB(0xff,0x00,0x00);
		
		y=(height/2)+(pBuf->data[x*2+1]>>8);
		if(y<0) y=0; else if(y>=height) y=height-1;
		p=(VOUT*) ( (BYTE*) pvo+pdesko_lPitch*y);
		p+=x;
		p->SetRGB(0x00,0xff,0x00);
	}


}



CVJGenerateWave::CVJGenerateWave()
{
}

CVJGenerateWave::~CVJGenerateWave()
{
}

void CVJGenerateWave::Release()
{

}

int CVJGenerateWave::MessageProc(int msg,DWORD wParam,DWORD lParam)
{

	if(msg==VJM_EFFECT)
		return Effect( (VJEFFECTINFO*)wParam );
}

#define	EFFECTGENERATE EffectGenerateWave
int CVJGenerateWave::Effect(VJEFFECTINFO *pInfo)
#include "vjgenerateeffect_effect.h"

////////////////////////////////////////////////////////////////////////////////////////////







